From fbd0a8de264529fa562981b14e1e388750bf6eda Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 19 2020 22:22:59 +0000
Subject: [PATCH 1455/2232] Combine 'extra' and 'module' modules in test suite


---

diff --git a/tests/BUCK b/tests/BUCK
index 5bbe500..4bdcc46 100644
--- a/tests/BUCK
+++ b/tests/BUCK
@@ -12,7 +12,6 @@ rust_test(
 rust_library(
     name = "ffi",
     srcs = [
-        "ffi/extra.rs",
         "ffi/lib.rs",
         "ffi/module.rs",
     ],
@@ -28,7 +27,6 @@ cxx_library(
     srcs = [
         "ffi/tests.cc",
         ":bridge/source",
-        ":extra/source",
         ":module/source",
     ],
     headers = {
@@ -44,11 +42,6 @@ rust_cxx_bridge(
 )
 
 rust_cxx_bridge(
-    name = "extra",
-    src = "ffi/extra.rs",
-)
-
-rust_cxx_bridge(
     name = "module",
     src = "ffi/module.rs",
 )
diff --git a/tests/BUILD b/tests/BUILD
index 57ffab9..b255a3c 100644
--- a/tests/BUILD
+++ b/tests/BUILD
@@ -15,7 +15,6 @@ rust_test(
 rust_library(
     name = "cxx_test_suite",
     srcs = [
-        "ffi/extra.rs",
         "ffi/lib.rs",
         "ffi/module.rs",
     ],
@@ -30,7 +29,6 @@ cc_library(
     srcs = [
         "ffi/tests.cc",
         ":bridge/source",
-        ":extra/source",
         ":module/source",
     ],
     hdrs = ["ffi/tests.h"],
@@ -47,12 +45,6 @@ rust_cxx_bridge(
 )
 
 rust_cxx_bridge(
-    name = "extra",
-    src = "ffi/extra.rs",
-    deps = [":impl"],
-)
-
-rust_cxx_bridge(
     name = "module",
     src = "ffi/module.rs",
     deps = [":impl"],
diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index 4b2cbdf..e583944 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -6,7 +6,7 @@ fn main() {
     }
 
     CFG.include_prefix = "tests/ffi";
-    let sources = vec!["lib.rs", "extra.rs", "module.rs"];
+    let sources = vec!["lib.rs", "module.rs"];
     cxx_build::bridges(sources)
         .file("tests.cc")
         .flag_if_supported(cxxbridge_flags::STD)
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 5844bd1..c408fb0 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -5,7 +5,6 @@
     clippy::trivially_copy_pass_by_ref
 )]
 
-pub mod extra;
 pub mod module;
 
 use cxx::{CxxString, CxxVector, UniquePtr};
diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
index 1952885..5846e11 100644
--- a/tests/ffi/module.rs
+++ b/tests/ffi/module.rs
@@ -8,3 +8,57 @@ pub mod ffi {
         fn c_take_unique_ptr(c: UniquePtr<C>);
     }
 }
+
+#[cxx::bridge(namespace = "tests")]
+pub mod ffi2 {
+    unsafe extern "C++" {
+        include!("tests/ffi/tests.h");
+
+        type D = crate::other::D;
+        type E = crate::other::E;
+        #[namespace = "F"]
+        type F = crate::other::f::F;
+        #[namespace = "G"]
+        type G = crate::other::G;
+
+        #[namespace = "H"]
+        type H;
+
+        fn c_take_trivial_ptr(d: UniquePtr<D>);
+        fn c_take_trivial_ref(d: &D);
+        fn c_take_trivial(d: D);
+        fn c_take_trivial_ns_ptr(g: UniquePtr<G>);
+        fn c_take_trivial_ns_ref(g: &G);
+        fn c_take_trivial_ns(g: G);
+        fn c_take_opaque_ptr(e: UniquePtr<E>);
+        fn c_take_opaque_ref(e: &E);
+        fn c_take_opaque_ns_ptr(e: UniquePtr<F>);
+        fn c_take_opaque_ns_ref(e: &F);
+        fn c_return_trivial_ptr() -> UniquePtr<D>;
+        fn c_return_trivial() -> D;
+        fn c_return_trivial_ns_ptr() -> UniquePtr<G>;
+        fn c_return_trivial_ns() -> G;
+        fn c_return_opaque_ptr() -> UniquePtr<E>;
+        fn c_return_ns_opaque_ptr() -> UniquePtr<F>;
+        fn c_return_ns_unique_ptr() -> UniquePtr<H>;
+        fn c_take_ref_ns_c(h: &H);
+
+        #[namespace = "other"]
+        fn ns_c_take_trivial(d: D);
+        #[namespace = "other"]
+        fn ns_c_return_trivial() -> D;
+
+        #[namespace = "I"]
+        type I;
+
+        fn get(self: &I) -> u32;
+
+        #[namespace = "I"]
+        fn ns_c_return_unique_ptr_ns() -> UniquePtr<I>;
+    }
+
+    impl UniquePtr<D> {}
+    impl UniquePtr<E> {}
+    impl UniquePtr<F> {}
+    impl UniquePtr<G> {}
+}
diff --git a/tests/test.rs b/tests/test.rs
index e5e1373..bf69379 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -1,6 +1,6 @@
 #![allow(clippy::assertions_on_constants, clippy::float_cmp, clippy::unit_cmp)]
 
-use cxx_test_suite::extra::ffi2;
+use cxx_test_suite::module::ffi2;
 use cxx_test_suite::{ffi, R};
 use std::cell::Cell;
 use std::ffi::CStr;

